import java.util.*;

/**
* Duplikatfreie Liste.
*/
public interface OrderedSet extends Set,List{

/**
* Fgt ein Element obj genau dann am Ende dieses OrderedSet
* hinzu, falls in  diesem OrderedSet nicht bereits ein Element
* other enthalten ist mit other.equals(obj). Der Wert null ist
* fr obj nicht zulssig und fhrt zu einer Exception.
*
* @return true, gdw. obj zuvor noch  nicht enthalten war.
*/
    public boolean add(Object obj);

/**
* Fgt ein Element obj genau dann an Position i dieses OrderedSet
* ein, falls in  diesem OrderedSet nicht bereits ein Element other
* enthalten ist mit other.equals(obj). Der Wert null ist fr obj
* nicht zulssig und fhrt zu einer Exception.
*/
    public void add(int i, Object obj);

/**
* Ersetzt das Element an Position i dieses OrderedSet genau dann
* durch das Element obj, falls in  diesem OrderedSet nicht bereits
* ein Element other enthalten ist mit other.equals(obj). Der Wert
* null ist fr obj nicht zulssig und fhrt zu einer Exception.
*
* @return das Element, dass zuvor an Position i  war oder null,
*         falls obj zuvor bereits enthalten war
*/
    public Object set(int i, Object obj);

/**
* Fgt genau die Elemente aus collection am Ende dieses
* OrderedSet hinzu, die nicht bereits zuvor enthalten waren.
*
* @return true, gdw. dieses OrderedSet als Folge dieses Aufrufs
*         gendert wurde
*/
    public boolean addAll(Collection collection);
/**
* Fgt genau die Elemente aus collection an Position i dieses
* OrderedSet hinzu, die nicht bereits zuvor enthalten waren.
*
* @return true, gdw. dieses OrderedSet als Folge dieses Aufrufs
*         gendert wurde
*/
    public boolean addAll(int i, Collection collection);
}
